module TicketflyPlus
    class Calls
        class Base
            attr_accessor :data
            def initialize(options={})
            end

            def next_page
                @data['nextPage'] ? self.class.new(next_page_string: @data['nextPage']) : @data['status']
            end
        end

        class List < Base
            CALL_STRING = '/list.json?'

            def initialize(options={})
                if options[:requestor_string]
                    @data = TicketflyPlus::Requestors::Base.request(
                        options[:requestor_string] + 
                        CALL_STRING + 
                        options[:params_list]
                    )
                else
                    @data = TicketflyPlus::Requestors::Base.next_page_request(options[:next_page_string])
                end
            end
        end

        class Upcoming < Base
            CALL_STRING = '/upcoming.json?'
            
            def initialize(options={})
                if options[:requestor_string]
                    @data = TicketflyPlus::Requestors::Base.request(
                        options[:requestor_string] + 
                        CALL_STRING + 
                        options[:params_list]
                    )
                else
                    @data = TicketflyPlus::Requestors::Base.next_page_request(options[:next_page_string])
                end
            end
        end
        
        class Featured < Base
            CALL_STRING = '/featured.json?'

            def initialize(options={})
                if options[:requestor_string]
                    @data = TicketflyPlus::Requestors::Base.request(
                        options[:requestor_string] + 
                        CALL_STRING + 
                        options[:params_list]
                    )
                else
                    @data = TicketflyPlus::Requestors::Base.next_page_request(options[:next_page_string])
                end
            end
        end

        class JustAnnounced < Base
            CALL_STRING = '/justAnnounced.json?'

            def initialize(options={})
                if options[:requestor_string]
                    @data = TicketflyPlus::Requestors::Base.request(
                        options[:requestor_string] + 
                        CALL_STRING + 
                        options[:params_list]
                    )
                else
                    @data = TicketflyPlus::Requestors::Base.next_page_request(options[:next_page_string])
                end
            end
        end

        class Past < Base
            CALL_STRING = '/past.json?'

            def initialize(options={})
                if options[:requestor_string]
                    @data = TicketflyPlus::Requestors::Base.request(
                        options[:requestor_string] + 
                        CALL_STRING + 
                        options[:params_list]
                    )
                else
                    @data = TicketflyPlus::Requestors::Base.next_page_request(options[:next_page_string])
                end
            end
        end

        class OnSale < Base
            CALL_STRING = '/onsale.json?'

            def initialize(options={})
                if options[:requestor_string]
                    @data = TicketflyPlus::Requestors::Base.request(
                        options[:requestor_string] + 
                        CALL_STRING + 
                        options[:params_list]
                    )
                else
                    @data = TicketflyPlus::Requestors::Base.next_page_request(options[:next_page_string])
                end
            end
        end

        class Event  < Base
            CALL_STRING = '/event.json?'

            def initialize(options={})
                if options[:requestor_string]
                    @data = TicketflyPlus::Requestors::Base.request(
                        options[:requestor_string] + 
                        CALL_STRING + 
                        options[:params_list]
                    )
                else
                    @data = TicketflyPlus::Requestors::Base.next_page_request(options[:next_page_string])
                end
            end
        end
    end
end
